#!/bin/sh

# Copyright (C) 2004 Mark Seaborn
#
# This file is part of Plash.
#
# Plash is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Plash is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Plash; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
# USA.


. src/config.sh

CONFIG_H=$(
  echo "/* Auto-generated by make-config-h.sh from config.sh */"
  echo "#define PLASH_VERSION \"$PLASH_VERSION\""
  echo "#define JAIL_DIR \"$JAIL_DIR\""
  echo "#define PLASH_SETUID_BIN_INSTALL \"$PLASH_SETUID_BIN_INSTALL\""
  echo "#define LIB_INSTALL \"$LIB_INSTALL\""
  echo "#define PLASH_LD_LIBRARY_PATH \"$PLASH_LD_LIBRARY_PATH\""
  echo "#define UID_RANGE_START $UID_RANGE_START"
  echo "#define UID_RANGE_END   $UID_RANGE_END"
  echo "#define UID_LOCK_DIR \"$UID_LOCK_DIR\""
  echo "#define UID_LOCK_DIR2 \"$UID_LOCK_DIR2\""
  if test "$USE_GTK" = yes; then
    echo "#define USE_GTK"
  else
    echo "/* #undef USE_GTK */"
  fi
)

# Don't write the file if there is no change
if [ ! -e gensrc/config.h ] ||
   [ "$CONFIG_H" != "$(cat gensrc/config.h)" ]; then
  echo "$CONFIG_H" >gensrc/config.h
fi
